; Usb_Watcher.asm Detect when a USB device is plugged in 
;                 Help from ragdog 
;        
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\shell32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\shell32.lib

CTEXT macro Text
    local szText
    .data
    szText byte Text, 0
    .code
    exitm <offset szText>   
endm

DlgProc			 PROTO	:HWND,:UINT,:WPARAM,:LPARAM
GetVolumeName            PROTO	:DWORD

DEV_BROADCAST_HDR STRUCT
dbch_size       DWORD   ?
dbch_devicetype DWORD   ?
dbch_reserved   DWORD   ?
DEV_BROADCAST_HDR ENDS


DEV_BROADCAST_VOLUME STRUCT
dbcv_size        DWORD   ?
dbcv_devicetype  DWORD   ?
dbcv_reserved    DWORD   ?
dbcv_unitmask    DWORD   ?
dbcv_flags       DWORD   ?
DEV_BROADCAST_VOLUME ENDS

.const

IDD_DIALOG	             equ 1000
IDC_INFO                 equ 101

DBT_DEVICEARRIVAL        equ 8000h
DBT_DEVICEREMOVECOMPLETE equ 8004h
DBT_DEVTYP_VOLUME        equ 2h

.data

szDrivePath              db "%c:\%s",0
No_Batch_File  db      "Batch file is not present.",0
Batch_File     db      "C:\Bat\BAK_ALL.bat",0
AppName        db      "UsbToHD",0

.data?

hInstance		  dd   ?
szBuf               db   16 dup(?)
szComspec	        db	 MAX_PATH dup(?)
szAppname	        db	 MAX_PATH dup(?)
ProcessInfo	        PROCESS_INFORMATION<?>
StartupInfo	        STARTUPINFO<?>

.code

start:
	
	invoke GetModuleHandle,NULL
	mov	 hInstance,eax

      invoke InitCommonControls
      invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
      invoke ExitProcess,0

;DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

DlgProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

local dbt_h : DEV_BROADCAST_HDR
local dbt_v : DEV_BROADCAST_VOLUME
	
      .if uMsg==WM_INITDIALOG
	
       invoke ShowWindow,hWnd,SW_SHOWMINIMIZED

    .elseif uMsg == WM_DEVICECHANGE
            .if wParam == DBT_DEVICEARRIVAL
                   mov ebx, lParam
                assume ebx:ptr DEV_BROADCAST_HDR
                .if [ebx].dbch_devicetype == DBT_DEVTYP_VOLUME

            ; Check if batch file is present
invoke GetFileAttributes,offset Batch_File

.IF EAX == 0FFFFFFFFh
   invoke MessageBox, 0, ADDR No_Batch_File, ADDR AppName,MB_ICONINFORMATION
   invoke  ExitProcess,NULL
.ENDIF

      invoke	GetStartupInfo, addr StartupInfo
	invoke	GetEnvironmentVariable, CTEXT('ComSpec'), addr szComspec, sizeof szComspec
	invoke	wsprintf, addr szAppname, CTEXT('"%s" /c "C:\Bat\BAK_ALL.bat"'), addr szComspec
	invoke	CreateProcess, 0, addr szAppname, 0, 0, FALSE, \
				NORMAL_PRIORITY_CLASS, 0, 0, addr StartupInfo, addr ProcessInfo

invoke	WaitForSingleObject, ProcessInfo.hProcess, INFINITE

                assume edx:nothing
                .endif
                assume ebx:ptr nothing
            .elseif wParam == DBT_DEVICEREMOVECOMPLETE
              
            .endif

	.elseif uMsg==WM_COMMAND

	.elseif uMsg==WM_CLOSE

	@Exit:
		invoke EndDialog,hWnd,0
	.else
		mov		eax,FALSE
		ret
	.endif
	      mov		eax,TRUE
	ret

DlgProc endp

end start
